package com.androidnative.billing.interfaces;

import com.androidnative.billing.models.BillingResult;


/**
 * Callback for setup process. This listener's {@link #onIabSetupFinished} method is called
 * when the setup process is complete.
 */
public interface OnBillingSetupFinishedListener {
    /**
     * Called to notify that setup is complete.
     *
     * @param result The result of the setup process.
     */
    public void onSetupFinished(BillingResult result);
}
